## ros-kinetic-lex-common 1.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(lex_common)

SET(LEX_COMMON_VERSION 1.0.0)

find_package(aws_common REQUIRED)

add_compile_options(-std=c++11 -fPIC)

if (AWSSDK_FOUND)
    set(SERVICE lex)
    AWSSDK_DETERMINE_LIBS_TO_LINK(SERVICE AWSSDK_LIBS)
    link_directories("${AWSSDK_LIB_DIR}")
endif ()

include_directories(
        include
        ${aws_common_LIBRARIES})

## Declare a C++ library
add_library(${PROJECT_NAME}
        src/lex_common.cpp
        src/lex_param_helper.cpp)

## Specify libraries to link a library or executable target against
target_link_libraries(${PROJECT_NAME}
        ${aws_common_LIBRARIES})

target_include_directories(${PROJECT_NAME} PRIVATE ${AWSSDK_INCLUDE_DIR})
target_include_directories(${PROJECT_NAME} PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>)


#############
## Install ##
#############

## Mark executables and/or libraries for installation
install(TARGETS ${PROJECT_NAME}
        EXPORT "${PROJECT_NAME}-targets"
        ARCHIVE DESTINATION lib
        LIBRARY DESTINATION lib
        RUNTIME DESTINATION bin
        )

## Mark cpp header files for installation
install(
        DIRECTORY include/
        DESTINATION include/
)

export(TARGETS ${PROJECT_NAME}
        FILE "${PROJECT_BINARY_DIR}/${PROJECT_NAME}-targets.cmake")
export(PACKAGE ${PROJECT_NAME})

CONFIGURE_FILE(${PROJECT_NAME}Config.cmake.in
        ${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake @ONLY)
CONFIGURE_FILE(${PROJECT_NAME}ConfigVersion.cmake.in
        ${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake @ONLY)

INSTALL(FILES ${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake DESTINATION share/${PROJECT_NAME}/cmake)
INSTALL(FILES ${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake DESTINATION share/${PROJECT_NAME}/cmake)
INSTALL(EXPORT ${PROJECT_NAME}-targets DESTINATION share/${PROJECT_NAME}/cmake)


#############
## Testing ##
#############

enable_testing()
find_common_test_packages()
if(GMOCK_LIBRARY)

    macro(link_test_target target_name)
        if(TARGET ${target_name})
            target_include_directories("${target_name}" PRIVATE ${HEADERS_FOR_TESTS})
            target_link_libraries("${target_name}" ${LIBS_FOR_TESTS})
        endif()
    endmacro()

    set(TEST_TARGET test_lex_common)

    set(TEST_FILES
        test/lex_param_test.cpp
        test/lex_common_test.cpp
        test/lex_interactor_test.cpp
        test/parameter_reader_mock.cpp
    )

    add_common_gtest(${TEST_TARGET}
        ${TEST_FILES}
    )

    set(LIBS_FOR_TESTS
        ${GTEST_LIBRARIES}
        pthread
        ${GMOCK_LIBRARY}
        ${aws_common_LIBRARIES}
        ${PROJECT_NAME}
    )

    set(HEADERS_FOR_TESTS
        ${aws_common_INCLUDE_DIRS}
        ${AWSSDK_INCLUDE_DIR}
        ${GTEST_INCLUDE_DIR}
        test/include
    )

    link_test_target(${TEST_TARGET})

endif()

=== debian/changelog ===
ros-kinetic-lex-common (1.0.0-1xenial) xenial; urgency=high

  * Merge pull request #4 <https://github.com/aws-robotics/lex-common/issues/4> from aws-robotics/ros2_migration
    Cleanup CMakeLists.txt and README
  * recover test code coverage
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
  * cleanup cmake file to improve compatbility with ros1 and ros2
    Signed-off-by: Miaofei <mailto:miaofei@amazon.com>
  * Change ament to ament_cmake
  * Change ament to ament_cmake
  * Merge pull request #1 <https://github.com/aws-robotics/lex-common/issues/1> from aws-robotics/lex-dev
    Lex Initial Development
  * Revise code to resolve pull request comments
    **Summary**
    * Add ament dependencies in package.xml
    * Remove incompatible test from compiling with catkin
    * Revise README.md with up to date instructions
  * Sync ParameterPath with utils-ros2
  * Ament uncrustify tests
  * Increase code coverage
    **Code Coverage Summary**
    lex_common.h                                   | 100%    16| 100%  11|
    lex_configuration.h                            | 100%     1| 100%   2|
    lex_common.cpp                                 |85.5%    76|85.7%   7|
    lex_param_helper.cpp                           | 100%    12| 100%   1|
  * Add tests for lex_common to Aws Lex
  * Add lex common interfaces for ros1 and ros2
    **Summary**
    Creates readme for how to build lex common
    Interface can be used as a library for any C++ usage of Lex
    Ament_uncrustify reformat code
    ament_cpplint formatting changes
    **Tests**
    Unit Tests
  * Add lex common interfaces for ros1 and ros2
    **Summary**
    Creates readme for how to build lex common
    Interface can be used as a library for any C++ usage of Lex
    Ament_uncrustify reformat code
    ament_cpplint formatting changes
    **Tests**
    Unit Tests
  * Contributors: AAlon, M. M, Miaofei, Ross Desmond

 -- AWS RoboMaker <ros-contributions@amazon.com>  Thu, 29 Aug 2019 07:00:00 -0000

=== debian/control ===
Source: ros-kinetic-lex-common
Section: misc
Priority: extra
Maintainer: AWS RoboMaker <ros-contributions@amazon.com>
Build-Depends: debhelper (>= 9.0.0), cmake, google-mock, libgtest-dev, ros-kinetic-aws-common (>= 2.0.0), ros-kinetic-catkin, ros-kinetic-ros-environment
Homepage: http://wiki.ros.org/aws_common
Standards-Version: 3.9.2

Package: ros-kinetic-lex-common
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-kinetic-aws-common (>= 2.0.0)
Description: Lex Common utilities, intended for use by Lex clients

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-lex-common//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
